Automatically Deploy Debian Firewalls with bash scripting

Automation is as necessary as any other aspect of systems administration in any critical or production environment where growth and scalability are moving at a significant pace.

Growth in any organization is obviously a good thing. In the systems administrator’s perspective, however, growth can mean more time spent deploying systems and less time spent focusing on other duties.

Automating the server deployment process is the natural next step when your organization has grown to a point where time efficiency becomes more relevant and noticeable to your business owners.

This is the first in a series of posts here where we will explain and share shell scripts that automate the deployment process of several key debian linux based systems. These scripts automate the patching, configuration and implementation of said systems.

They will certainly have to be modified to fit your organization’s needs and standards obviously, but hopefully it will give you a starting point to base your automation / roll-out policies.

Making your life easier and more automated is always a good thing! 😉

#!/bin/sh
# Debian FW deployer script
# Version 1.0

PROGNAME="$0"
VERSION="1.0"

# working directory for deployer process.
WORKDIR="/root"

# tasks left (this is updated every step to accommodate recovery during
# the deployer  process)
TASKS="./deploy-fw.tasks"

init_tasks() {
	# This function will write a new tasks file.
	# it's called from the main body of the script if a tasks file does not exist.
	cat > $TASKS< /etc/hostname
	echo `hostname` > /etc/mailname
	echo "done."
	return 0
}

usage() {
	echo "[+] Usage: $PROGNAME"
	echo
	return 0
}

###############################
### MAIN SCRIPT STARTS HERE ###
###############################

# installer_splash
installer_splash

# fix working dir.
cd $WORKDIR

# does our installer file exist? if not, initalize it.
if [ ! -f $TASKS ]
then
	echo "[+] No task file found, installation will start from beginning."
	init_tasks
	if (($? != 0))
	then
		echo "[!] ERROR: Cannot create tasks file. Installation will not continue."
		exit 1
	fi
else 
	echo "[+] Tasks file located - starting where you left off."
fi

# start popping off tasks from the task list and running them.
# pop first step off of the list
STEP=`head -n 1 $TASKS`
while [ ! -z $STEP ]
do
	# execute the function.
	echo -e "nn###################################"
	echo "[+] Running step: $STEP"
	echo -e "###################################nn"
	$STEP
	if (($? != 0))
	then
		# command failed.
		echo "[!] ERROR: Step $STEP failed!"
		echo "    Installation will now abort - you can pick it up after fixing the problem"
		echo
		exit 1
	fi
	# throw up a newline just so things don't look so crowded
	echo
	# remove function from function list.
	perl -pi -e "s/$STEPn?//" $TASKS || exit 1
	STEP=`head -n 1 $TASKS`
done

# clean_up_and_reboot
echo "[+] Installation finished - cleaning up."
clean_up_and_reboot

# script is done now - termination should happen with clean_up_and_reboot.
echo "[!] Should not be here!"
exit 1

Menu